#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <graphics.h>
#define RESTART '*'
#define ZOOMOUT '-'
#define SPACE ' '
#define ESC 27
#define UP 72
#define DOWN 80
#define LEFT 75
#define RIGHT 77
#define LUP '8'
#define LDOWN '2'
#define LLEFT '4'
#define LRIGHT '6'
#define LMOVE 10
#define FTYPE float
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif
#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#define PMIN -2
#define QMIN -1.25
#define PMAX 1.333333333333
#define QMAX 1.25
#define MaxIteration 256
#define BigNumber 10
#define MAXPOS 32
struct pOnScreen
{int x;int y;};
int mx,my;
int mc;
struct {
	FTYPE pmin;
	FTYPE qmin;
	FTYPE pmax;
	FTYPE qmax;} poss[MAXPOS];
int posp=0;
FTYPE dp,dq;
FTYPE pmin,qmin,pmax,qmax;
pOnScreen chPoint(pOnScreen r,int is,pOnScreen a);
void newCoor(void);
void graphInit(void);
int fractalColor(FTYPE x0,FTYPE y0,FTYPE p,FTYPE q);
void fractal(void);
void main(void)
{
	int i=0;
	int key;
	graphInit();
	pmin=PMIN;
	qmin=QMIN;
	pmax=PMAX;
	qmax=QMAX;
	while (i==0)
	{
		dp=(pmax-pmin)/mx;
		dq=(qmax-qmin)/my;
		fractal();
		if ((key=getch())==0) getch();
		if (key==ESC)
		{
			closegraph();
			exit(0);
		}
		if (key==ZOOMOUT&&posp!=0)
		{
			posp--;
			pmin=poss[posp].pmin;
			qmin=poss[posp].qmin;
			pmax=poss[posp].pmax;
			qmax=poss[posp].qmax;
		} else if (key==RESTART)
		{
			pmin=PMIN;
			qmin=QMIN;
			pmax=PMAX;
			qmax=QMAX;
			posp=0;
		} else newCoor();
	}
	closegraph();
}
void newCoor(void)
{
	int x0,y0;
	int x1,y1;
	int c;
	pOnScreen a;
	pOnScreen b;
	if (posp>=MAXPOS)
	{
		c=getch();
		closegraph();
		if (c!=ESC)
		{
			printf("Too many zooms!\n");
			getch();
			exit(1);
		}
		exit(0);
	}
	a.x=(mx+1)/2;
	a.y=(my+1)/2;
	a=chPoint(a,0,a);
	c=getpixel(a.x,a.y);
	b=chPoint(a,1,a);
	putpixel(a.x,a.y,c);
	x0=min(a.x,b.x);
	y0=min(a.y,b.y);
	x1=max(a.x,b.x);
	y1=max(a.y,b.y);
	poss[posp].pmin=pmin;
	poss[posp].qmin=qmin;
	poss[posp].pmax=pmax;
	poss[posp].qmax=qmax;
	pmin=poss[posp].pmin+dp*x0;
	qmin=poss[posp].qmin+dq*y0;
	pmax=poss[posp].pmin+dp*x1;
	qmax=poss[posp].qmin+dq*y1;
	posp++;
}
pOnScreen chPoint(pOnScreen r,int is,pOnScreen a)
{
	int c=0;
	int key;
	int oc;
	int i=0;
	while (i==0)
	{
		oc=getpixel(r.x,r.y);
		while (!kbhit())
		{
			c=++c%(mc+1);
			putpixel(r.x,r.y,c);
			if (is!=0) putpixel(a.x,a.y,c);
		}
		putpixel(r.x,r.y,oc);
		key=getch();
		if (key==32) i=1;
		else if (key==27)
		{
			closegraph();
			exit(0);
		}
		else if (key==0)
		{
			key=getch();
			switch (key)
			{
				case UP:if (r.y>0) r.y--;break;
				case DOWN:if (r.y<my) r.y++;break;
				case LEFT:if (r.x>0) r.x--;break;
				case RIGHT:if (r.x<mx) r.x++;break;
			}
		}
		else switch (key)
		{
			case LUP:if (r.y>=LMOVE) r.y-=LMOVE;break;
			case LDOWN:if (r.y<=my-LMOVE) r.y+=LMOVE;break;
			case LLEFT:if (r.x>=LMOVE) r.x-=LMOVE;break;
			case LRIGHT:if (r.x<=mx-LMOVE) r.x+=LMOVE;break;
		}
	}
	return r;
}
void fractal(void)
{
	int x,y;
	FTYPE p,q;
	for (x=0;x<=mx;x++) for (y=0;y<=my;y++)
	{
		p=pmin+dp*x;
		q=qmin+dq*y;
		putpixel(x,y,fractalColor(0,0,p,q));
	}
}
int fractalColor(FTYPE x0,FTYPE y0,FTYPE p,FTYPE q)
{
	int c=MaxIteration;
	FTYPE m=BigNumber*BigNumber;
	FTYPE r;
	FTYPE x=x0,y=y0;
	FTYPE xt,yt;
	int n=0;
	do
	{
		xt=x;
		yt=y;
		x=xt*xt-yt*yt+p;
		y=2*xt*yt+q;
		r=x*x+y*y;
		n++;
	} while (n<c&&r<m);
	return (int)((double)(n-1)/(c-1)*mc);
}
void graphInit(void)
{
	int gdriver = VGA, gmode=VGAHI;
	int i;
	int errorcode;
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();
	if (errorcode != grOk)
	{
		 printf("Graphics error: %s\n", grapherrormsg(errorcode));
		 printf("Press any key to halt:");
		 getch();
		 exit(1);
	}
	mx=getmaxx();
	my=getmaxy();
	mc=getmaxcolor();
}